const LocationHistory = require('../Model/LocationHistory');
const LocationHistoryServices = require('../Services/CreateServices')('LocationHistory');


module.exports.getAllLocationHistory = async (req, res) => {
    try {
        const LocationHistoryResult = await LocationHistoryServices.find();

        if (!LocationHistoryResult.status || LocationHistoryResult.error) return res.status(500).send(LocationHistoryResult);

        return res.status(200).send(LocationHistoryResult);
    }
    catch (e) {
        console.log("🚀 ~ file: LocationHistory.controller.js:14 ~ module.exports.getAllLocationHistory= ~ e:", e)
        return res.status(500).send({ status: false, error: "Internal Server Error!" });
    }
};

module.exports.getLocationHistory = async (req, res) => {
    try {
        const id = req.params.id;
        // console.log(id)
        if (!(id && id.length != 0)) return res.status(404).send({ status: false, error: "Not Found" });

        const LocationHistoryResult = await LocationHistoryServices.findById(id);
        if (!LocationHistoryResult.status || LocationHistoryResult.error) return res.status(500).send(LocationHistoryResult);

        return res.status(200).send(LocationHistoryResult);
    }
    catch (e) {
        console.log("Error: ", e);
        return res.status(500).send({ status: false, error: "Internal Server Error!" });
    }
};

module.exports.createLocationHistory = async (req, res) => {
    try {
        const LocData = req.local.LocationHistory;

        const alreadyCreated = await LocationHistoryServices.find({ query: { userId: LocData.userId } });
        if (!alreadyCreated.status || alreadyCreated.error) return res.status(500).send(alreadyCreated);

        if (alreadyCreated.LocationHistory.length == 0) {

            LocData.date = new Date();
            const LocationHistoryResult = await LocationHistoryServices.create(LocData);
            if (!LocationHistoryResult.status || LocationHistoryResult.error) return res.status(500).send(LocationHistoryResult);

            return res.status(200).send(LocationHistoryResult);
        }
        else {
            return res.status(500).send({ status: false, error: "Already Created!" });
        }
    }
    catch (err) {
        console.log(err)
        return res.status(500).send({ status: false, error: err });
    }
};
