const fs = require('fs');
const path = require('path');
const Permission = require('../Model/Permission');
const fsPermission = require('../Constants/permission');
const User = require('../Model/User');
const mongoose = require('mongoose');
// const request = require('request');
const UserPer = require('../Model/UserPer');
const userServices = require('../Services/User.services');
const DocumentListServices = require('../Services/DocumentList.services');
const OrganizationServices = require('../Services/Organization.services');
const clientServices = require('../Services/Client.services');
const branchServices = require('../Services/Branch.services');
const zoneServices = require('../Services/Zone.services');
const utilitiesController = require('../Controllers/Utilities.controller');
const MongoClient = require('mongodb').MongoClient;
const assert = require('assert');
const Role = require('../Model/Role');
const Empanelment = require('../Model/Empanelment');
const CaseLog = require('../Model/CaseLog');
const Case = require('../Model/Case');
const permission = require('../Constants/permission');
const { user } = require('../Constants/permission');
const PermissionBinary = require('../Services/PermissionToBinaryServices');



exports.savePermission = async (req, res) => {

	var array = [];
	let binaryva = 1;
	await Promise.all(
		Object.keys(fsPermission).map(async (permission, index) => {
			var title = permission;
			var permissions = [];

			await Promise.all(
				Object.keys(fsPermission[permission]).map(async (prmsn, key) => {

					if (key === 0) {

						binaryva = 1;
					}
					else {
						binaryva = (binaryva * 2);
					}

					// console.log("index:", index);

					console.log("keys :", index + "_" + key, " binary: " + binaryva);

					var label = prmsn;
					var name = label;
					var obj = { label: name, name: title + "_" + label, value: binaryva };

					permissions.push(obj);

					console.log("binary ==== :", binaryva);
				})
			)

			var finalObj = { title: title, permission: permissions };

			array.push(finalObj);
		})

	);
	console.log("before promise");

	// console.log(array);

	fs.writeFileSync("demo.json", JSON.stringify(array));
	return res.status(200).send({ status: true });

}


exports.saveUserPermission = async (req, res) => {
	const permission = { "case": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "lead": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "user": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "client": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "branch": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "MIS": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "roles": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "account": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "dropDown": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } }, "organization": { "access": { "value": false }, "create": { "value": false }, "delete": { "value": false }, "edit": { "value": false }, "export": { "value": false }, "import": { "value": false }, "list": { "value": false }, "view": { "value": false } }, "bill": { "access": { "value": true }, "create": { "value": true }, "delete": { "value": true }, "edit": { "value": true }, "export": { "value": true }, "import": { "value": true }, "list": { "value": true }, "view": { "value": true } } };

	console.log(await PermissionBinary.PermissionToBinary(permission));

	return res.status(200).send({ status: true });
}

// exports.saveUserPermission = async(req, res)=>{
// 	try{
// 		// .sort({createdAt: 1})
// 		var users = await User.find({type: {$ne:"CREDITOFFICER"}}).sort({createdAt: 1});
// 		// var users = await User.findOne({_id: "5fc75d341095af19d8b34239"});
// 		// console.log(users);
// 		await Promise.all(

// 			users.map(async (user)=>{

// 			var arr = {};
// 			var finalArr = {};
// 			await Promise.all(
// 				user.role.map(async (roles)=>{
// 					const RL = await Role.findOne({name: roles});
// 					// console.log(RL);
// 					if(RL !== null){
// 						const perJson = await fs.readFileSync('./Utils/permissions.json');

// 						await Promise.all(
// 							JSON.parse(perJson).map(async (per)=>{
// 								const JSONtitle = per.title;
// 								const JSONpermissions = per.permission;

// 								await Promise.all(
// 									JSONpermissions.map(async (jsnpermission)=>{

// 										const JSONPermissionLbl = jsnpermission.label;
// 										const JSONValue = jsnpermission.value;
// 										// console.log(RL.permissions, RL.permissions);
// 										if(JSONtitle in RL.toJSON().permissions && JSONPermissionLbl in RL.toJSON().permissions[JSONtitle])
// 										{
// 											// console.log(RL.permissions[JSONtitle]);
// 											if(RL.permissions[JSONtitle][JSONPermissionLbl].value !== undefined)
// 											{
// 												if(RL.permissions[JSONtitle][JSONPermissionLbl].value){
// 													var status = "1";
// 												}
// 												else{
// 													var status = "0";
// 												}


// 												if(arr[JSONtitle] == undefined || arr[JSONtitle][JSONValue] == undefined)
// 												{
// 													var tempArr = {};

// 													if(arr[JSONtitle] != undefined){
// 														tempArr = arr[JSONtitle];
// 													}

// 													tempArr[JSONValue] = status;
// 													// console.log(typeof(arr[JSONtitle]));
// 													arr[JSONtitle] = tempArr;
// 												}
// 												else{
// 													if(arr[JSONtitle][JSONValue] === "0"){

// 														arr[JSONtitle][JSONValue] = status;
// 													}
// 												}

// 												// console.log(JSONtitle+" > "+JSONPermissionLbl+" > "+RL.permissions[JSONtitle][JSONPermissionLbl].value);
// 											}
// 										}
// 									})
// 								)
// 							})
// 						)

// 					}
// 					// RL.permissions

// 				})
// 			);

// 			await Promise.all(
// 				Object.keys(arr).map(async(prmsion)=>{
// 					var bit = Object.values(arr[prmsion]).reverse().join('');

// 					finalArr[prmsion] = bit;
// 				})
// 			)

// 			user = user.toJSON();
// 			user.permission = finalArr;

// 			await UserPer.create(user);
// 			})

// 		);

// 		// console.log(users);
// 		return res.status(200).send({status: true});
// 	}
// 	catch(err){
// 		console.log("Error :", err);
// 	}
// }

module.exports.capitalize = async (s) => {
	return s.charAt(0).toUpperCase() + s.slice(1)
}
// module.exports.changeRoleType = async (req, res) => {
// 	try {

// 		const orgResult = await userServices.findAll({type: {$ne:"CREDITOFFICER"}});
// 		// if (!UserResult.status || UserResult.error) return res.status(500).send(UserResult);
// 		console.log(typeof UserResult.users)

// 		const url = "mongodb://amdin:" + encodeURIComponent('mongo@Som2020#') + "@beta.vastukala.co.in:27017/realvalue?authSource=admin";

// 		// Database Name
// 		const dbName = 'realvalue';

// 		// Use connect method to connect to the server
// 		MongoClient.connect(url, async function (err, client) {
// 			assert.equal(null, err);
// 			// console.log("Connected successfully to server");
// 			const db = client.db(dbName);
// 			const collection = db.collection('users');

// 			await Promise.all(UserResult.users.map(async (value) => {
// 				let data = value.toJSON();

// 				if (typeof data.role == 'object') {

// 					// const replacement = {
// 					// 	role: [data.role]
// 					// };
// 					const result = await collection.updateOne({ _id: data._id }, { $set: { role: data.role[0] } }, { new: true });
// 					// console.log(typeof datarole);

// 					// if (result.matchedCount === 1) {
// 					// 	console.log("Matched " + result.matchedCount + " documents.");
// 					// }
// 					// if (result.modifiedCount === 1) {
// 					// 	console.log("Updated one document.");
// 					// }
// 					// if (result.upsertedCount === 1) {
// 					// 	console.log(
// 					// 		"Inserted one new document with an _id of " + result.upsertedId._id
// 					// 	);
// 					// }
// 				}

// 			}));

// 			client.close();
// 		});

// 	}
// 	catch (e) {
// 		console.log(e)
// 	}
// }
module.exports.changePermission = async (req, res) => {
	try {
		const RL = await Role.find();
		RL.map(async (value) => {
			let data = value.toJSON();
			if (!data.permission) {
				const res = {};
				var obj = data.permissions;
				for (const key in obj) {
					// let value = obj[key];
					// console.log(value);
					var str = "";
					for (const subKey in obj[key]) {
						if (obj[key][subKey].value == true) {
							str += 1;
						}
						else {
							str += 0;
						}
						// str.split("").reverse().join("")
						res[key] = str.split("").reverse().join("");
					}
				}
				// console.log(data._id);
				// console.log(res);
				const updateRole = await Role.findOneAndUpdate({ name: data.name }, { permission: res });
			}
		})
		console.log("completed")
	}

	catch (e) {
		console.log(e)
	}
}

module.exports.changeOrgIdType = async (req, res) => {
	try {

		const clientResult = await clientServices.getAllClients();
		if (!clientResult.status || clientResult.error) return res.status(500).send(clientResult);

		const url = "mongodb://amdin:" + encodeURIComponent('mongo@Som2020#') + "@beta.vastukala.co.in:27017/realvalue?authSource=admin";

		// Database Name
		const dbName = 'realvalue';

		// Use connect method to connect to the server
		MongoClient.connect(url, async function (err, client) {
			assert.equal(null, err);
			// console.log("Connected successfully to server");
			const db = client.db(dbName);
			const collection = db.collection('clients');

			await Promise.all(clientResult.clients.map(async (value) => {
				let data = value.toJSON();

				console.log(typeof data.organization._id);
				// if (typeof data.role == 'object') {

				// 	// const replacement = {
				// 	// 	role: [data.role]
				// 	// };
				const result = await collection.updateOne({ _id: data._id }, { $set: { 'organization._id': data.organization._id } }, { new: true });
				// console.log(typeof datarole);

				// 	// if (result.matchedCount === 1) {
				// 	// 	console.log("Matched " + result.matchedCount + " documents.");
				// 	// }
				// 	// if (result.modifiedCount === 1) {
				// 	// 	console.log("Updated one document.");
				// 	// }
				// 	// if (result.upsertedCount === 1) {
				// 	// 	console.log(
				// 	// 		"Inserted one new document with an _id of " + result.upsertedId._id
				// 	// 	);
				// 	// }
				// }

			}));

			client.close();
			console.log("COMPLETED");
		});

	}
	catch (e) {
		console.log(e)
	}
}

module.exports.deleteRegNo = async (req, res) => {
	try {

		const UserResult = await userServices.findAll({ role: { $ne: "VALUER" } });
		// if (!UserResult.status || UserResult.error) return res.status(500).send(UserResult);
		// console.log(typeof UserResult.users)

		// const url = "mongodb://amdin:" + encodeURIComponent('mongo@Som2020#') + "@beta.vastukala.co.in:27017/realvalue?authSource=admin";

		// Database Name
		// const dbName = 'realvalue';

		// Use connect method to connect to the server
		// MongoClient.connect(url, async function (err, client) {
		// 	assert.equal(null, err);
		// console.log("Connected successfully to server");
		// const db = client.db(dbName);
		// const collection = db.collection('users');

		await Promise.all(UserResult.users.map(async (value) => {
			let data = value.toJSON();

			if (data.role != 'VALUER') {
				console.log(data, " before")
				delete data.registrationNo;
				console.log("==================== after ============", data.registrationNo)
				// const replacement = {

				// 	role: [data.role]
				// };
				const result = await userServices.editUser(data._id, data);
				console.log(result)
				// console.log(typeof datarole);

				// if (result.matchedCount === 1) {
				// 	console.log("Matched " + result.matchedCount + " documents.");
				// }
				// if (result.modifiedCount === 1) {
				// 	console.log("Updated one document.");
				// }
				// if (result.upsertedCount === 1) {
				// 	console.log(
				// 		"Inserted one new document with an _id of " + result.upsertedId._id
				// 	);
				// }
			}

		}));

		// client.close();
		console.log("Close ....")
		// });

	}
	catch (e) {
		console.log(e)
	}
}

module.exports.updateDocumentList = async (req, res) => {
	try {

		const orgID = "5f2bdee67813470eb443deb4";
		const datas = req.body;

		const Organization = await OrganizationServices.getById(orgID);
		if (!Organization.status) return res.status(500).send(Organization);

		const org = Organization.Organizations;
		for (key in datas) {
			datas.organization = org;
			datas.document = datas[key];
			console.log(datas)
			const DocumentListResult = await DocumentListServices.createDocumentList(datas);
		}
		console.log("COMPLETED .....!");
	}
	catch (e) {
		console.log(e)
	}
}
module.exports.deleteZone = async (req, res) => {
	try {
		const zoneId = req.params.id;

		const findZone = await zoneServices.getZone(zoneId);
		if (!findZone.status) return res.status(500).send(findZone);
		if (findZone != null || findZone != {}) {
			const zone = await zoneServices.deleteZone(zoneId);
			if (!zone.status) return res.status(500).send(zone);

			const branch_res = await branchServices.editMultipleBranch({ 'zone._id': zoneId }, { $unset: { "zone": 1 } });
			if (!branch_res.status) return res.status(500).send(branch_res);

			console.log(branch_res, " branch response ");
			console.log("Deleted...");

			return res.status(200).send({ status: true, message: "Zone Deleted" });
		} else {

			return res.status(500).send({ status: false, message: "Zone Not Found!" });

		}



	}
	catch (e) {
		console.log(e)
	}
}

module.exports.deleteStatusFromCaseLog = async (req, res) => {
	try {
		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})

		await Promise.all(CaseResult.cases.map(async data => {
			await CaseLog.find({ "case._id": data._id, caseStatus: "DATAENTRYSTART" })
				.then(async result => {

					if (result.length > 1) {
						let obj = result[result.length - 1];

						await arr.push(result[result.length - 1])

						console.log(result.length, "=============================================")
						// console.log({ "case._id": result.case._id, caseStatus: "DATAENTRYSTART", _id: { $ne: mongoose.Types.ObjectId(obj._id) } })
						await result.map(async r => {

							await CaseLog.remove({ "case._id": r.case._id, caseStatus: "DATAENTRYSTART", _id: { $ne: mongoose.Types.ObjectId(obj._id) } }).then(val => {
								console.log("response : ", val)
							}).catch(e => {
								console.log("error", e)
							})
						})
					}

				}).catch(err => {
					console.log(err);
					// return { status: false, error: err }
				})
		}))

		console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

// ====================== CDN img path Script for Staging Server ============================

module.exports.changeUserProfile = async (req, res) => {
	try {

		let arr = [];
		const UserResult = await User.find({ type: "EMPLOYEE" })
			.then(result => {

				return { status: true, users: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		await Promise.all(UserResult.users.map(async data => {
			const id = data._id.toString();
			if ("profilePhoto" in data) {
				var profileImg = data.profilePhoto
				console.log("== ProfileImg: ==", profileImg, "== id: ==", id);

				// if (!fs.existsSync(process.env.CDN_PATH + '/users')) {
				// 	fs.mkdirSync(process.env.CDN_PATH + '/users');
				// }
				if (!fs.existsSync(process.env.CDN_PATH + '/users/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/users/' + id);
				}
				var fileName = path.basename(profileImg);
				fileName = "profilePhoto_" + fileName;
				// console.log(filename)
				let currentPath = process.cwd() + "/" + profileImg;
				// const destination = "/cdn/empanelmentLetters/" + id + "/" + Date.now() + "_" + fileName;
				const destination = path.join(process.env.CDN_PATH + "/users/" + id + "/" + fileName);
				// console.log(destination, "destination")

				if (fs.existsSync(currentPath)) {
					// call function for move file
					await utilitiesController.moveFile(currentPath, destination);

					const filepath = path.join("users/", id, "/", fileName);
					data.profilePhoto = filepath;
					// await data.save();
					const user_res = await User.findByIdAndUpdate(id, data);
				}
				else {
					console.log("no");
					fs.writeFile(process.cwd() + "/errors/usr-profile-" + id + '.txt', currentPath, function (err) {
						if (err) throw err;
						console.log('File is created successfully.');
					});
				}
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeUserDocs = async (req, res) => {
	try {

		let arr = [];
		const UserResult = await User.find({ type: "EMPLOYEE" })
			.then(result => {
				return { status: true, users: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		await Promise.all(UserResult.users.map(async data => {
			const id = data._id.toString();
			if (data.employeeDocs.length != 0) {
				console.log(id)
				await Promise.all(data.employeeDocs.map(async (docs, index) => {
					if (docs.images.length != 0) {
						console.log("In IF :", id)

						const empDocs = docs.images;
						data.employeeDocs[index].images = [];


						await Promise.all(empDocs.map(async file => {


							if (!fs.existsSync(process.env.CDN_PATH + '/users')) {
								fs.mkdirSync(process.env.CDN_PATH + '/users');
							}
							if (!fs.existsSync(process.env.CDN_PATH + '/users/' + id)) {
								fs.mkdirSync(process.env.CDN_PATH + '/users/' + id);
							}
							const fileName = "employeeDocs_" + file.name;
							let currentPath = process.cwd() + "/" + file.path;

							const destination = path.join(process.env.CDN_PATH, "users", id, fileName);

							// console.log(currentPath, " ====", destination);
							// call function for move file
							if (fs.existsSync(currentPath)) {
								await utilitiesController.moveFile(currentPath, destination).then(async mvres => {

									file.path = path.join("users", id, fileName);
									file.name = fileName;
									if (data.employeeDocs[index].images) {
										console.log(file, " ======== IF ===========")
										await data.employeeDocs[index].images.push(file);
										console.log("In IF", data.employeeDocs[index])
									}
								}).catch(err => {
									console.log("Error in Catch", err);
								})
							}
							else {
								console.log("no");
								fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
									if (err) throw err;
									console.log('File is created successfully.');
								});
							}
						}))
					}

				}))
				const user_res = await User.findByIdAndUpdate(id, data);
			}
		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeCaseDocumentPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.documents.length > 0) {
				console.log("documents :", id)


				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}
				await Promise.all(data.documents.map(async file => {


					if (file.path) {
						var fileName = path.basename(file.path);
						fileName = "document_" + fileName;

						let currentPath = process.cwd() + "/" + file.path;

						const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

						if (fs.existsSync(currentPath)) {

							// call function for move file
							await utilitiesController.moveFile(currentPath, destination);
							const filepath = path.join("cases", id, fileName);

							file.fileName = fileName;
							file.path = filepath;
						}
						else {
							console.log("no");
							fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
								if (err) throw err;
								console.log('File is created successfully.');
							});
						}
					}
				}))
				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}
module.exports.changeExternalImgPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.externalImages.length > 0) {
				console.log("externalImages :", id)

				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}

				await Promise.all(data.externalImages.map(async file => {

					if (file.path) {
						var fileName = path.basename(file.path);
						fileName = "compositionExternalImg_" + fileName;

						let currentPath = process.cwd() + "/" + file.path;

						if (fs.existsSync(currentPath)) {


							const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

							// call function for move file
							await utilitiesController.moveFile(currentPath, destination);
							const filepath = path.join("cases", id, fileName);

							file.name = fileName;
							file.path = filepath;
						}
						else {
							console.log("no");
							fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
								if (err) throw err;
								console.log('File is created successfully.');
							});
						}
					}
				}))
				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}
module.exports.changeCompositionImgPath = async (req, res) => {
	try {

		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.composition.length != 0) {
				// console.log(id)
				await Promise.all(data.composition.map(async (docs, index) => {
					if (docs.images.length > 0) {
						console.log("In Image", id)
						const cmpDocs = docs.images;
						data.composition[index].images = [];

						await Promise.all(cmpDocs.map(async file => {

							if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
								fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
							}

							var fileName = path.basename(file.path);

							fileName = "compositionImg_" + fileName;

							// const fileName = "compositionImg_" + file.name;

							let currentPath = process.cwd() + "/" + file.path;
							const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

							if (fs.existsSync(currentPath)) {
								// call function for move file
								await utilitiesController.moveFile(currentPath, destination).then(async mvres => {

									file.path = path.join("cases", id, fileName);
									file.name = fileName;
									if (data.composition[index].images) {
										// console.log(file, " ======== IF ===========")
										await data.composition[index].images.push(file);
										console.log("In IF ", data.composition[index])
									}
								}).catch(err => {
									console.log("Error in Catch", err);
								})
							}
							else {
								console.log("no");
								fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
									if (err) throw err;
									console.log('File is created successfully.');
								});
							}
						}))
					}
				}))
				const case_res = await Case.findByIdAndUpdate(id, data);
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}
module.exports.changeOtherCompositionImgPath = async (req, res) => {
	try {

		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.otherComposition.length != 0) {
				// console.log(id)
				await Promise.all(data.otherComposition.map(async (docs, index) => {
					if (docs.images.length > 0) {
						console.log("In Image", id)
						const cmpDocs = docs.images;
						data.otherComposition[index].images = [];

						await Promise.all(cmpDocs.map(async file => {

							if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
								fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
							}

							var fileName = path.basename(file.path);

							fileName = "compositionImg_" + fileName;

							// const fileName = "compositionImg_" + file.name;

							let currentPath = process.cwd() + "/" + file.path;
							const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

							if (fs.existsSync(currentPath)) {
								// call function for move file
								await utilitiesController.moveFile(currentPath, destination).then(async mvres => {

									file.path = path.join("cases", id, fileName);
									file.name = fileName;
									if (data.otherComposition[index].images) {
										// console.log(file, " ======== IF ===========")
										await data.otherComposition[index].images.push(file);
										console.log("In IF ", data.otherComposition[index])
									}
								}).catch(err => {
									console.log("Error in Catch", err);
								})
							}
							else {
								console.log("no");
								fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
									if (err) throw err;
									console.log('File is created successfully.');
								});
							}
						}))
					}
				}))
				const case_res = await Case.findByIdAndUpdate(id, data);
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeRouteImgPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.routeMap.routeMapDetail.routeMapImg) {
				console.log("routeMapImg :", id)

				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}
				if (data.routeMap.routeMapDetail.routeMapImg != "") {
					var fileName = path.basename(data.routeMap.routeMapDetail.routeMapImg);
					fileName = "routeMap_" + fileName;

					let currentPath = process.cwd() + "/" + data.routeMap.routeMapDetail.routeMapImg;

					const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

					if (fs.existsSync(currentPath)) {

						// call function for move file
						await utilitiesController.moveFile(currentPath, destination);
						const filepath = path.join("cases", id, fileName);

						data.routeMap.routeMapDetail.routeMapImg = filepath;
					}
					else {
						console.log("no");
						fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
							if (err) throw err;
							console.log('File is created successfully.');
						});
					}
				}

				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}
		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeLocaltionRouteImgPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();


			if (data.routeMap.locationMapImg.length > 0) {
				console.log("locationMapImg :", id)

				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}

				await Promise.all(data.routeMap.locationMapImg.map(async file => {

					if (file.image) {
						var fileName = path.basename(file.image);
						fileName = "routeMap_" + fileName;

						let currentPath = process.cwd() + "/" + file.image;

						const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

						if (fs.existsSync(currentPath)) {
							// call function for move file
							await utilitiesController.moveFile(currentPath, destination);
							const filepath = path.join("cases", id, fileName);

							file.fileName = fileName;
							file.image = filepath;
						}
						else {
							console.log("no");
							fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
								if (err) throw err;
								console.log('File is created successfully.');
							});
						}
					}
				}))
				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}
		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeIgrImgPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();


			if (data.igrRate.igrImage) {

				console.log("igrImage :", id)

				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}

				if (data.igrRate.igrImage != "") {
					var fileName = path.basename(data.igrRate.igrImage);
					fileName = "igr_" + fileName;

					let currentPath = process.cwd() + "/" + data.igrRate.igrImage;

					const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

					if (fs.existsSync(currentPath)) {
						// call function for move file
						await utilitiesController.moveFile(currentPath, destination);
						const filepath = path.join("cases", id, fileName);
						// file.fileName = fileName;
						data.igrRate.igrImage = filepath;
					}
					else {
						console.log("no");
						fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
							if (err) throw err;
							console.log('File is created successfully.');
						});
					}

				}
				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}
		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeIndicatorImgPath = async (req, res) => {
	try {

		let arr = [];
		const CaseResult = await Case.find()
			.then(result => {
				return { status: true, cases: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/cases')) {
			fs.mkdirSync(process.env.CDN_PATH + '/cases');
		}
		await Promise.all(CaseResult.cases.map(async data => {
			const id = data._id.toString();

			if (data.indicatorArr.length > 0) {

				console.log("indicatorImage :", id)

				if (!fs.existsSync(process.env.CDN_PATH + '/cases/' + id)) {
					fs.mkdirSync(process.env.CDN_PATH + '/cases/' + id);
				}
				await Promise.all(data.indicatorArr.map(async file => {

					if (file.image != "") {
						var fileName = path.basename(file.image);

						fileName = "indicator_" + fileName;

						let currentPath = process.cwd() + "/" + file.image;

						// let currentPath = path.join(process.env.CDN_PATH, "cases", id, fileName)
						// fileName = "indicator_" + fileName;
						const destination = path.join(process.env.CDN_PATH, "cases", id, fileName);

						if (fs.existsSync(currentPath)) {

							// call function for move file
							await utilitiesController.moveFile(currentPath, destination);
							const filepath = path.join("cases", id, fileName);

							// file.fileName = fileName;
							file.image = filepath;
						}
						else {
							console.log("no");
							fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
								if (err) throw err;
								console.log('File is created successfully.');
							});
						}
					}
				}))
				// data.save();
				const case_res = await Case.findByIdAndUpdate(id, data);
			}
		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeEmpanelmentImgPath = async (req, res) => {
	try {

		let arr = [];
		const EmpanelmentResult = await Empanelment.find()
			.then(result => {
				return { status: true, empanelmentLetters: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		if (!fs.existsSync(process.env.CDN_PATH + '/empanelmentLetters')) {
			fs.mkdirSync(process.env.CDN_PATH + '/empanelmentLetters');
		}
		await Promise.all(EmpanelmentResult.empanelmentLetters.map(async data => {
			const id = data.zoneId.toString();
			// console.log(id)
			if (data.fileType == "Pdf") {

				if (data.empanelmentLetter.length > 0) {

					console.log("empanelmentLetters :", id)

					if (!fs.existsSync(process.env.CDN_PATH + '/empanelmentLetters/' + id)) {
						fs.mkdirSync(process.env.CDN_PATH + '/empanelmentLetters/' + id);
					}
					const empArr = data.empanelmentLetter;

					await Promise.all(empArr.map(async (file, index) => {
						// console.log(file);
						var fileName = path.basename(file);

						fileName = "empanelmentLetters_" + fileName;

						let currentPath = process.cwd() + "/" + file;
						const destination = path.join(process.env.CDN_PATH, "empanelmentLetters", id, fileName);

						if (fs.existsSync(currentPath)) {

							// call function for move file
							await utilitiesController.moveFile(currentPath, destination);
							const filepath = path.join("empanelmentLetters", id, fileName);

							let filesObj = {};
							filesObj.fileName = fileName;
							filesObj.path = filepath;

							// return file;
							data.empanelmentLetter[index] = filesObj
							console.log("FILE : ", data.empanelmentLetter[index])
						}
						else {
							console.log("no");
							fs.writeFile(process.cwd() + "/errors/" + id + '.txt', currentPath, function (err) {
								if (err) throw err;
								console.log('File is created successfully.');
							});
						}
					}))
				}

				// 	// data.save();
				console.log("ID : ", data._id);
				await Empanelment.findOneAndUpdate({ _id: data._id }, data)
					.then(result => {
						console.log("result", result)
					}).catch(err => {
						console.log("err", err);
					})
			}

		}))

		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}

module.exports.changeUserDocsFiletype = async (req, res) => {
	try {

		let arr = [];
		const UserResult = await User.find({ type: "EMPLOYEE" })
			.then(result => {
				return { status: true, users: result }
			}).catch(err => {
				console.log(err);
				return { status: false, error: err }
			})
		await Promise.all(UserResult.users.map(async (data, index) => {
			const id = data._id.toString();
			if (data.employeeDocs.length != 0) {

				console.log(data.employeeDocs.length)
				const empDocs = data.employeeDocs;
				UserResult.users[index].employeeDocs = [];

				// console.log(id)
				await Promise.all(empDocs.map(async (docs) => {
					if (docs.images.length != 0) {
						console.log("In IF :", id)
						console.log("fileType :", docs.fileType)


						if (!docs.fileType) {
							console.log(id, "=====", docs);
							docs.fileType = "Image"
						}
						// await Promise.all(docs.images.map(async file => {

						// 	var ext = file.name.substr(file.name.lastIndexOf('.') + 1);
						// 	console.log("extension :", ext);
						// 	if (ext == 'pdf') {
						// 		docs.fileType = "Pdf"
						// 	}
						// 	else {
						// 		docs.fileType = "Image"
						// 	}

						// 	// 	file.path = path.join("users", id, fileName);
						// 	// 	file.name = fileName;

						// }))

						// console.log(data)
						if (UserResult.users[index].employeeDocs) {
							console.log(docs, " ======== IF ===========")
							await UserResult.users[index].employeeDocs.push(docs);
							console.log("In IF", UserResult.users[index])
						}
					}

				}))
				// data.save();
				const user_res = await User.findByIdAndUpdate(id, data);
			}
		}))
		//6104f65764b190712161e4f2
		// console.log(arr);
		console.log("completed");
		return res.send({ status: true, message: "COMPLETED" });
	}
	catch (e) {
		console.log(e)
		return res.send({ status: false, error: e })
	}
}
