const OrganizationServices = require('../Services/Organization.services');

module.exports = async (req, res, next) => {

    if (req.local.user.role === "SUPERADMIN") next();
    
    const organization_id = req.local.user.organization;
 
    await OrganizationServices.getById(organization_id).then(org => {
        // console.log(org);
        req.local.organization_id = req.local.user.organization;
        req.local.organization = org.body;
        next();
    }).catch(err => {
        return res.status(401).send({ status: false, auth: false, error: "Organization Not Found" });
    });
}