const mongoose = require('mongoose');
const { userSchema } = require('./CommonSchema');

const Schema = mongoose.Schema;

const approvalRequest = Schema({
    type: {
        type: String,
        default: "CONVERT_TO_CASE",
        enum: ["CONVERT_TO_CASE", "CANCEL_CASE"]
    },
    organizationId: {
        type: Schema.Types.ObjectId,
        ref: 'Organization',
    },
    caseId: {
        type: Schema.Types.ObjectId,
        ref: 'Case',
    },
    otherInfo: {},
    requestedBy: userSchema,
    remark: { type: String },
    actionedBy: userSchema,
    completedAt: { type: Date },
    status: {
        type: String,
        default: "PENDING",
        enum: ["PENDING", "APPROVED", "REJECTED"]
    }
}, { timestamps: true });


module.exports = mongoose.model('ApprovalRequest', approvalRequest);