
const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const caseLogSchema = Schema({
    user: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'User'
        },
        firstName: {
            type: String,
        },
        lastName: {
            type: String,
        },
        shortName: {
            type: String,
        },
        email: {
            type: String,
        },
        mobileNo: {
            type: String,
        },
        workMobileNo: {
            type: String,
        },
        role: {
            type: String
        }
    },
    case: {
        _id: {
            type: String
        },
        caseNumber: {
            type: String
        },
        typeOfReport: {
            value: {
                type: String
            },
            label: {
                type: String
            }
        },
        ownerName: {
            type: String
        },
        ownerPhoneNo: {
            type: String
        },
        clientType: {
            value: {
                type: String
            },
            label: {
                type: String
            }
        }
    },
    organization: {
        _id: {
            type: String,
            // type: Schema.Types.ObjectId,
            // ref: 'Organization'
        },
        name: {
            type: String
        },
        email: {
            type: String
        },
        shortName: {
            type: String
        }
    },
    caseStatus: {
        type: String
    },
    reason: {
        type: String
    },
    dateTime: {
        type: String
    }

}, { timestamps: true });

module.exports = mongoose.model('CaseLog', caseLogSchema);