
const mongoose = require('mongoose');
const UserServices = require('../Services/User.services');

const Schema = mongoose.Schema;

const dynamicFormSchema = Schema({
    orgId: {
        type: Schema.Types.ObjectId,
        ref: 'Organization'
    },
    clientId: {
        type: Schema.Types.ObjectId,
        ref: 'Client'
    },
    description: {
        type: String,
    },
    constructionWorkStatus: {
        type: String
    },
    module: {
        address: {
            // label: "Property Address",
            label: {
                type: String
            },
            fields: {
                selectNo: {// dynamic key
                    // label: "Flat / Unit / Office / Gala No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                floorNo: {// dynamic key
                    // label: "Floor No",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                buildingNo: {// dynamic key
                    // label: "Building No",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                buildingName: {// dynamic
                    // label: "Building Name",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                projectName: {// dynamic
                    // label: "Project Name",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                wing: {// dynamic
                    // label: "Wing -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                landmark: {// dynamic
                    // label: "Landmark",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                plotNo: {// dynamic
                    // label: "Plot No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                selectArea: {// dynamic
                    // label: "Sector/Area.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                oldSurveyNumber: {// dynamic
                    // label: "Old Survey No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                newSurveyNumber: {// dynamic
                    // label: "New/Current Survey No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                hissaNo: {// dynamic
                    // label: "Hissa No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                CTSNo: {// dynamic
                    // label: "CTS No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                street1: {// dynamic
                    // label: "Street 1",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                street2: {// dynamic
                    // label: "Street 2",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                blockNo: {// dynamic
                    // label: "Block No",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                village: {// dynamic
                    // label: "Village -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                municipalityWardNo: {// dynamic
                    // label: "Municipality Ward No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                khataNo: {// dynamic
                    // label: "Khata No",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                mouza: {// dynamic
                    // label: "Mouza -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                tahasilNo: {// dynamic
                    // label: "Tahasil -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                SRO: {// dynamic
                    // label: "SRO",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                policeStation: {// dynamic
                    // label: "Police Station(P.S)",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                suburb: {// dynamic
                    // label: "Suburb",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                GUTNo: {// dynamic
                    // label: "Gut No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                taluka: {// dynamic
                    // label: "Taluka -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                district: {// dynamic
                    // label: "District -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                city: {// dynamic
                    // label: "City",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                postalCode: {// dynamic
                    // label: "Postal Code",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                state: {// dynamic
                    // label: "State -",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                country: {// dynamic
                    // label: "Country",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },

            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        buildingDetails: {
            // label: "Building Details",
            label: {
                type: String
            },
            fields: {
                constructionWorkStatus: {// dynamic key
                    // label: "Construction Work Status:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                dateOfConstruction: {// dynamic key
                    // label: "",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: ["buildingDetails.constructionWorkStatus"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                totalLifeBuilding: {// dynamic key
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: ["buildingDetails.constructionWorkStatus"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                estimatedAge: {// dynamic
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: ["buildingDetails.constructionWorkStatus"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                ageOfBuilding: {// dynamic
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: ["buildingDetails.constructionWorkStatus"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                planningArea: {// dynamic
                    // label: "Description of the locality Residential / Commercial / Mixed:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                typeOfStructure: {// dynamic
                    // label: "Type Of Structure:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                typeOfFoundation: {// dynamic
                    // label: "Type Of Foundations:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                qualityOfConstruction: {// dynamic
                    // label: "Quality Of Construction:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                materialUsedList: {// dynamic
                    // label: "Material & Technology Used:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                buildingSpecification: {// dynamic
                    // label: "Specifications:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                structuralSafety: {
                    // label: "Structural Safety:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                protAgainstNatDis: {
                    // label: "Protection Against Natural Disaster Viz. Earthquakes:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                sewerageSystem: {
                    // label: "Underground sump – capacity and type of construction:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                walls: {
                    // label: "Compound walls:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                partitions: {
                    // label: "Partitions:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                roof: {
                    // label: "Roofing And Terracing:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                waterTank: {
                    // label: "Water Supply:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                pavementLaid: {
                    // label: "Is Pavement laid around ?:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                carParking: {
                    // label: "Parking:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                appearanceOfTheBuilding: {
                    // label: "Appearance Of The Building:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                maintenanceOfTheBuilding: {
                    // label: "Maintenance Of The Building:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                maintenanceIssues: {
                    // label: "Maintenance Issues:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                visibleDamageInBuilding: {
                    // label: "Visible Damage In The Building:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                systemOfAirConditioning: {
                    // label: "System Of Air-Conditioning:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                provisionOfFirefighting: {
                    // label: "Provision Of Firefighting:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                groundStilt: {
                    // label: "Ground / Stilt:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfBasement: {
                    // label: "No Of Basement:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfPodium: {
                    // label: "No Of Podium :",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfAmenityFloors: {
                    // label: "No Of Amenity Floors:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfFloors: {
                    // label: "Number Of Floors:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                flatFloorNo: {
                    // label: "Flat On Which Floor:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: ["address.floorNo"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfLifts: {
                    // label: "Number Of Lifts:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                noOfDwellingUnitsInBuilding: {
                    // label: "Number Of Flates Per Floor :",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                asthetikLook: {
                    // label: "Descriptive Account On Whether The Building Is Modern, Old Fashioned, Plain Looking Or Decorative, Heritage Value, Presence Of Landscape Elements Etc.:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
                underConstruction: {
                    // label: "Construction Details ",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    },
                },
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            },

        },
        marketability: { // dynamic key
            // label: "Marketability",
            label: {
                type: String
            },
            fields: {
                marketabilityList: {// dynamic key
                    // label: "How Is The Marketability?:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                anyFavouringForExtraPotentialValue: {// dynamic key
                    // label: "What are the factors favouring for an extra Potential Value?",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                negativeFactorsOfAffectMarketValue: {// dynamic
                    // label: "Any negative factors are observed which affect the market value in general?",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                }
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        flatOutgoing: {
            // label: "Flat Outgoing",
            label: {
                type: String
            },
            fields: {
                assessmentNo: {// dynamic key
                    // label: "1) Assessment No.",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                taxPaidHolderName: {// dynamic key.
                    // label: "2) Tax paid in the name of",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                taxAmount: {// dynamic
                    // label: "3) Tax amount",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                electricityServiceConnectionNo: {// dynamic
                    // label: "Electricity Service connection No",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                meterCardHolderName: {// dynamic
                    // label: "Meter Card is in the name of",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                undividedAreaOfLandAsPerSaleDeed: {// dynamic
                    // label: "What is the undivided area of land as per Sale Deed?",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                floorSpaceIndex: {// dynamic
                    // label: "What is the floor space index (app.)",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                areaStatusList: {// dynamic
                    // label: "Is It Posh / I Class / Medium / Ordinary?:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                propertyTypeOfUseList: {// dynamic
                    // label: "Is It Being Used For Residential Or Commercial Purpose?:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                propertyOccupiedByList: {// dynamic
                    // label: "Is It Owner-Occupied Or Let Out?:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                monthlyRent: {// dynamic
                    // label: "If rented, what is the monthly rent?",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                tenantName: {// dynamic
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: ["flatOutgoing.propertyOccupiedByList"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                }
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        flatSpecifications: {
            // label: "Flat Specifications",
            label: {
                type: String
            },
            fields: {
                roof: {// dynamic key
                    // label: "Roof:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                flooring: {// dynamic key
                    // label: "Flooring:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                doors: {// dynamic key
                    // label: "Doors:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                windows: {// dynamic
                    // label: "Windows:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                fittings: {// dynamic
                    // label: "Fittings:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                finishing: {// dynamic
                    // label: "Finishing:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },

            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        generalInformation: { // dynamic key
            // label: "General Information",
            label: {
                type: String
            },
            fields: {
                purposeOfValuation: {// dynamic key
                    // label: "Purpose For Which The Valuation Is Made:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                ownership: {// dynamic key
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                populationClassList: {// dynamic key
                    // label: "High / Middle / Poor:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                populationGroupList: {// dynamic
                    // label: "Urban / Semi Urban / Rural:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                extraDetailOfProperty: {// dynamic
                    // label: "Brief description of the property (Including Leasehold / freehold etc.)",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                townplanApprovedByList: {// dynamic
                    // label: "Coming Under Corporation Limit / Village Panchayat / Municipality:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                whetherCoveredUnderAnyState: {// dynamic
                    // label: "Whether Covered Under Any State / Central Govt. Enactments (E.G., Urban Land Ceiling Act) Or Notified Under Agency Area/ Scheduled Area / Cantonment Area:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                asPerActualAgreement: {// dynamic
                    // label: "As Per Actual",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                asPerDocumentAgreement: {// dynamic
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // label: "As Per Document",
                    label: {
                        type: String
                    },
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                }
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        compositeRateAdoptedAfterDepreciation: { // dynamic key
            // label: "Composite Rate Adopted After Depreciation",
            label: {
                type: String
            },
            fields: {
                remark: {// dynamic key
                    // label: "REMARKS –",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                salvageValue: {
                    // label: "salvage Value",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: ["buildingDetails.ageOfBuilding"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                depreciationPercentage: {// dynamic key
                    // label: "2) Depreciation percentage assuming the salvage value as",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "Inputs",
                    // dependencies: ["compositeRateAdoptedAfterDepreciation.salvageValue", "buildingDetails.ageOfBuilding"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                depreciationRatioOfBuilding: {// dynamic
                    // label: "3) Depreciated Ratio of the building %",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: ["buildingDetails.ageOfBuilding"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },

                depreciatedCostOfConstruction: {
                    // label: "Total composite rate arrived for Valuation",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "Inputs",
                    // dependencies: ["buildingDetails.ageOfBuilding"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                depreciatedBuildingRate: {
                    // label: "1) Depreciated building rate VI (a)",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "Inputs",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                }
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        rateDetails: { // dynamic key
            // label: "Rate Details",
            label: {
                type: String
            },
            fields: {
                property: {// dynamic key
                    // label: "Property:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                rateType: {// dynamic key
                    // label: "Rate Type:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                areaType: {// dynamic
                    // label: "Area Type:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                squareMeter: {
                    // label: "Square Meter:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                area: {
                    // label: "Square Feet:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                floor: {
                    // label: "Floor:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                source: {
                    // label: "Source:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                expectedPrice: {
                    // label: "Expected Price:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                expectedRate: {
                    // label: "Expected Rate/Sq. Ft:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "textarea",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                image: {
                    // label: "Apply ScreenShot:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "image",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                builtUpPercentage: {
                    // label: "Built Up Percentage:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: ["rateDetails.areaType"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                builtUpExpectedRate: {
                    // label: "BuiltUp Expected Rate/Sq. Ft:",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "Text",
                    // dependencies: ["rateDetails.areaType"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                }
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        valuation: { // dynamic key
            // label: "Details of Valuation",
            label: {
                type: String
            },
            fields: {
                presentValueOfTheFlat: {// dynamic key
                    // label: "Present value of the flat incl. car parking, if provided)",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: ["buildingDetails.carParking"],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                wardrobes: {// dynamic key
                    // label: "Wardrobes",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "dropdown",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                showcases: {// dynamic
                    // label: "Showcases",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                kitchenArrangements: {
                    // label: "Kitchen arrangements",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                superfineFinish: {
                    // label: "Superfine finish",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                interiorDecorations: {
                    // label: "Interior Decorations",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                electricityDeposits: {
                    // label: "Electricity deposits / electrical fittings, etc",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                extraCollapsibleGates: {
                    // label: "Extra collapsible gates / grill works etc",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                potentialValue: {
                    // label: "Potential value, if any",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                others: {
                    // label: "Others / Car Parking",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
            },
            editable: {
                type: Boolean
            },
            show: {
                type: Boolean
            }
        },
        propertyComposition: { // dynamic key
            // label: "Flat Area Details",
            label: {
                type: String
            },
            fields: {
                propertyComposition: {// dynamic key
                    // label: "Flat Area Details",
                    label: {
                        type: String
                    },
                    type: {
                        type: String
                    },
                    // type: "SubModule",
                    // dependencies: [],
                    dependencies: [{
                        type: String
                    }],
                    displayOnly: {
                        type: Boolean
                    },
                    show: {
                        type: Boolean
                    },
                    required: {
                        type: Boolean
                    },
                    editable: {
                        type: Boolean
                    }
                },
                editable: {
                    type: Boolean
                },
                show: {
                    type: Boolean
                }
            },
            routeMap: { // dynamic key
                // label: "Location & Route Map",
                label: {
                    type: String
                },
                fields: {
                    siteEngineerLatLng: {// dynamic key
                        // label: "Site Engineer Lat, Lng :",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "text",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    finalLatLng: {// dynamic key
                        // label: "Final Lat, Lng :",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "text",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    routeStation: {// dynamic
                        // label: "Station Type:",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "dropdown",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    stationName: {// dynamic
                        // label: "Nearest Station:",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "textarea",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    routeLat: {// dynamic
                        // label: "Latitude :",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "textarea",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    routeLng: {// dynamic
                        // label: "Longitude :",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "textarea",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    routeDistance: {// dynamic
                        // label: "Distance :",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "textarea",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    },
                    routeMapImg: {// dynamic
                        // label: "Apply ScreenShot:",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "image",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    }
                },
                editable: {
                    type: Boolean
                },
                show: {
                    type: Boolean
                }
            },
            propertyImage: { // dynamic key
                // label: "Property Image",
                label: {
                    type: String
                },
                fields: {
                    externalImages: {// dynamic key
                        // label: "External Images",
                        label: {
                            type: String
                        },
                        type: {
                            type: String
                        },
                        // type: "image",
                        // dependencies: [],
                        dependencies: [{
                            type: String
                        }],
                        displayOnly: {
                            type: Boolean
                        },
                        show: {
                            type: Boolean
                        },
                        required: {
                            type: Boolean
                        },
                        editable: {
                            type: Boolean
                        }
                    }
                },
                editable: {
                    type: Boolean
                },
                show: {
                    type: Boolean
                }
            },


        } // module end
    }
}, { timestamps: true });

module.exports = mongoose.model('DynamicForm', dynamicFormSchema);
