
const mongoose = require('mongoose');
const Schema = mongoose.Schema;
const moment = require('moment');

const empanelmentSchema = Schema({

    zoneId: {
        type: Schema.Types.ObjectId,
        ref: 'Zone'
    },
    valuerId: [{
        // type: String
        type: Schema.Types.ObjectId,
        ref: 'User'
    }],
    empanelmentNo: {
        type: String
    },
    isDelete: {
        type: Boolean,
        default: false
    },
    fileType: {
        type: String
    },
    startDate: {
        type: String
    },
    endDate: {
        type: String
    },
    isActive: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
    },
    feeStructure: {
        propertyType: [{
            type: String
        }],
        feeStructureObject: {
            type: Object
        }
    },
    empanelmentLetter: [{
        type: Object
    }],
    masterTypeOfPurpose: {
        type: String
    },
    assetsClass: { // 1) Land & Building / Immovable Property  2) Plant & Machinery  3) Securities or Financial Assets
        type: String
    }
}, { timestamps: true });
/**
 * @description This function is used for set Expiry Status into every object 
 * - This function is call from Utilities.controller => function Name : updateExpiryStatus
 * @returns this.save()
 */
empanelmentSchema.methods.isToBeExpired = function () {
    // console.log(" In Model ", this._id)

    const expiration = moment(this.endDate, "DD/MM/YYYY");
    const currentDate = moment(Date.now());
    const remainingDays = expiration.diff(currentDate, 'days');

    if (remainingDays <= 90) {
        // console.log("to be expired ")
        if (remainingDays <= 0) {
            this.expireStatus = 'EXPIRED';
            // console.log("in expired If ")
        }
        else {
            this.expireStatus = 'TOBEEXPIRED';
            // console.log("remainingDays : ", remainingDays, this.expireStatus)
        }

        // every week send Email., for that make new collection 

    }
    return this.save();
}

module.exports = mongoose.model('Empanelment', empanelmentSchema);