const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const indicatorSchema = Schema({
    organization: {
        name: String,
        id: {
            type: Schema.Types.ObjectId,
            ref: 'Organization',
        }
    },
    property: {
        type: String,
    },
    indicatorType: {
        type: String,       // indicator, sale instance, igr rate
    },
    areaType: {
        type: String,       // Carpet, BuiltUp, Salable
    },
    areaInSquareMeter: {
        type: String,
    },
    areaInSquareFeet: {
        type: String,
    },
    carpet: {
        area: String,
        rate: String,
    },
    builtUp: {
        area: String,
        rate: String,
        percentage: String,
    },
    saleable: {
        area: String,
        rate: String,
        percentage: String,
    },
    floor: {
        type: String,
    },
    source: {
        type: String
    },
    expectedTotalPrice: {
        type: String,
    },
    image: {
        type: String,
    },
    link: {
        type: String,
    },
    geo: {
        type: { type: String, default: 'Point', },
        coordinates: []
    },
    status: {
        type: Boolean,
        default: true
    }
}, { timestamps: true });

module.exports = mongoose.model('Indicator', indicatorSchema);