
const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const reportTemplateSchema = Schema({
    client: {
        _id: { type: String },
        type: {
            type: String,
            // required: true
        },
        name: {
            type: String,
            // required: true
        },
        phone: {
            type: String
        },
        displayName: {
            type: String,
        },
        initial: {
            type: String
        },
        uniqueId: {
            type: String
        },
        email: {
            type: String
        }
    },
    zone: {
        _id: {
            type: String
        },
        client: {
            _id: {
                type: String,
                // type: Schema.Types.ObjectId,
                // ref: 'User'
            },
            type: {
                type: String,
                // required: true
            },
            name: {
                type: String,
                // required: true
            },
            phone: {
                type: String
            }
        },
        zoneName: {
            type: String
        },
    },
    branch: {
        _id: { type: String },
        type: {
            type: String
        },
        branchCode: {
            type: String
        },
        name: {
            type: String,
        },
        email: {
            type: String,
        },
        mobileNo: {
            type: String,
        }
    },
    organization: {
        _id: {
            type: String
        },
        name: {
            type: String
        },
        email: {
            type: String
        },
        address: {
            type: String
        },
        type: {
            type: String
        },
        ownerName: {
            type: String
        },
        ownerLastName: {
            type: String
        },
        ownerFatherName: {
            type: String
        },
        ownerEmail: {
            type: String
        },
        city: {
            type: String
        },
        organization: {
            _id: {
                type: String
            },
            name: {
                type: String
            },
            email: {
                type: String
            },
            gstNo: {
                type: String
            }
        }
    },
    typeOfReport: {
        type: String        // flat, shop, gala, office, unit, row house
    },
    propertyType: {
        type: String        // commercial, residential, industrial
    },
    fileName: {
        type: String
    },
    workStatus: {
        type: String
    },
    xmlString: {
        type: String
    },
    htmlCode: {
        type: String
    },
    header: {
        type: String
    },
    footer: {
        type: String
    },
    status: {
        type: Boolean,
        default: true
    },
    isDeletes: {
        type: Boolean,
        default: false
    }
}, { timestamps: true });

module.exports = mongoose.model('ReportTemplate', reportTemplateSchema);