const fs = require('fs');
const sizeOf = require('image-size');
const PDFKit = require('pdfkit');

async function convertFolderToPDF(files, outputPath){
    let doc = new PDFKit();
    files.forEach((file, index) => {
        const filePath = `${file}`;
        try {
            const size = sizeOf(filePath);
            if (index === 0) {
                doc = new PDFKit({
                    size: [size.width, size.height]
                });
            } else {
                doc.addPage({ size: [size.width, size.height] });
            }

            doc.image(filePath, 0, 0, { width: size.width, height: size.height });
        } catch {
            return;
        }
    });
    doc.pipe(fs.createWriteStream(outputPath));
    return doc.end();
}


module.exports = convertFolderToPDF
