const router = require('express').Router();
// const isAuth = require('../Middleware/isAuth');
const Application = require('../Model/Application');

router.get('/app/versions', async (req, res) => {
    try {
        const data = await Application.find({});
        return res.status(200).send({ status: true, data })
    }
    catch (e) {
        console.log("🚀 ~ file: Application.routes.js:16 ~ router.get ~ e:", e)
        return res.status(500).send({ status: false, error: e })
    }
});

router.get('/app/version', async (req, res) => {
    try {
        const data = await Application.find({}).sort({ count: -1 }).limit(1);
        return res.status(200).send({ status: true, data: data[0] })
    }
    catch (e) {
        console.log("🚀 ~ file: Application.routes.js:16 ~ router.get ~ e:", e)
        return res.status(500).send({ status: false, error: e })
    }
});

router.post('/app/version', async (req, res) => {
    try {
        if (req.body.secret != "12345678") return res.send(404);
        const version = req.body;
        console.log(version);
        const data = await Application.create(version);
        return res.status(200).send({ status: true, data })
    }
    catch (e) {
        console.log("🚀 ~ file: Application.routes.js:16 ~ router.get ~ e:", e)
        return res.status(500).send({ status: false, error: e })
    }
});


module.exports = router;
