const express = require('express');
const router = express.Router();
const ApprovalRequestController = require('../Controllers/ApprovalRequest.controller');
const isAuth = require('../Middleware/isAuth');
const pagination = require('../Middleware/pagination');
const uploadFile = require('../Middleware/uploadFile');
const validation = require('../Middleware/validation');

// For list all Clients 
router.get('/approval-request-count', isAuth, ApprovalRequestController.getDashboardCount);
router.get('/approval-request', isAuth, pagination, ApprovalRequestController.getAll);

// For get one client 
router.get('/approval-request/:id', isAuth, ApprovalRequestController.get);

// For create new Client
router.post('/approval-request', isAuth, uploadFile.audioRemarks, validation.ApprovalRequestValidation, ApprovalRequestController.create);

// For update Client 
router.put('/approval-request/:id/:status', isAuth, uploadFile.audioRemarks, validation.ApprovalRequestValidation, ApprovalRequestController.update);

module.exports = router;

